package com.ekexiu.portal.dao;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.operator.DeleteWith;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectList;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectOne;

import com.ekexiu.portal.po.ArticleAgree;

@DAO
public abstract class ArticleAgreeDao {
	@Insert
	public abstract int insert(Connection con,ArticleAgree articleAgree)throws SQLException;
	
	@DeleteWith
	@From(ArticleAgree.class)
	public abstract int deleteAgree(Connection con,String operateId,String articleId)throws SQLException;
	
	@DeleteWith
	@From(ArticleAgree.class)
	public abstract int delete(Connection con,String articleId)throws SQLException;
	
	@SelectList
	public abstract List<ArticleAgree> query(Connection con,String articleId)throws SQLException;
	
	@SelectOne
	@Nullable
	public abstract ArticleAgree queryOne(Connection con,String operateId,String articleId)throws SQLException;
	
}
