package com.ekexiu.portal.dao;

import com.ekexiu.portal.po.ArticleRes;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.Where;
import org.jfw.apt.orm.annotation.dao.method.operator.DeleteWith;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectList;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

@DAO
public abstract class ArticleResDao {
	@Insert
	public abstract int insert(Connection con, ArticleRes articleRes) throws SQLException;

//	@QueryVal
//	@From(ArticlePro.class)
//	@Column(handlerClass = IntHandler.class, value = "COUNT(1)")
//	@DefaultValue("0")
//	public abstract int queryByArticleId(Connection con, String articleId) throws SQLException;
	@SelectList
	@Where("RESOURCE_ID IN (SELECT RESOURCE_ID FROM RESOURCE WHERE STATUS='1')")
	public abstract List<ArticleRes> query(Connection con,String articleId)throws SQLException;

	public List<ArticleRes> queryArticles(Connection con, String resourceId, int rows) throws SQLException {
		int index = 1;
        String sql = "SELECT A.ARTICLE_ID,A.RESOURCE_ID,A.CREATE_TIME FROM ARTICLE_RES A INNER JOIN ARTICLE AR ON A.ARTICLE_ID = AR.ARTICLE_ID "
        		+ " WHERE AR.STATUS = '1' AND A.RESOURCE_ID = ? ORDER BY PUBLISH_TIME DESC LIMIT " + rows;
        PreparedStatement ps = con.prepareStatement(sql);
        try{
            ps.setString(index++,resourceId);
            ResultSet rs = ps.executeQuery();
            try{
                List<ArticleRes> result = new ArrayList<ArticleRes>();
                while(rs.next()){
                    ArticleRes articleRes =  new ArticleRes();
                    articleRes.setArticleId(rs.getString(1));
                    articleRes.setResourceId(rs.getString(2));
                    articleRes.setCreateTime(rs.getString(3));
                    result.add(articleRes);
                }
                return result;
            }finally{
                try{rs.close();}catch(Exception e1){}
            }
        }finally{
            try{ps.close();}catch(Exception e2){}
        }
	}
	
	@DeleteWith
	@From(ArticleRes.class)
	public abstract int delete(Connection con, String articleId) throws SQLException;

	
	@SelectList
    @Where("ARTICLE_ID IN (SELECT ARTICLE_ID FROM ARTICLE WHERE STATUS = '1') ")
	public abstract List<ArticleRes> queryByResourceId(Connection con,String resourceId) throws SQLException;
}
