package com.ekexiu.portal.dao;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.OrderBy;
import org.jfw.apt.orm.annotation.dao.method.Select;
import org.jfw.apt.orm.annotation.dao.method.operator.DeleteWith;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;
import org.jfw.apt.orm.annotation.dao.method.operator.LimitQuery;
import org.jfw.apt.orm.annotation.dao.method.operator.QueryList;
import org.jfw.apt.orm.annotation.dao.param.LessThan;

import com.ekexiu.portal.po.ResearchAreaLog;
import com.ekexiu.portal.pojo.EditResearchAreaLog;

@DAO
public abstract class ResearchAreaLogDao {
	
	@Insert
	public abstract int insert(Connection con,ResearchAreaLog log) throws SQLException;
	
	@DeleteWith
	@From(ResearchAreaLog.class)
	public abstract int delete(Connection con,String professorId,String opreteProfessorId,String caption)throws SQLException;
	
	@DeleteWith
	@From(ResearchAreaLog.class)
	public abstract int delete(Connection con,String professorId,String caption)throws SQLException;
	@DeleteWith
	@From(ResearchAreaLog.class)
	public abstract int delete(Connection con,String professorId)throws SQLException;
	
	
	@LimitQuery
	@From(ResearchAreaLog.class)
	@Select(ResearchAreaLog.class)
	@OrderBy ("ORDER BY CREATE_TIME DESC")
	public abstract List<EditResearchAreaLog> queryLimit(Connection con,String professorId,String caption,@LessThan String createTime,int rows) throws SQLException;

	@QueryList
	@From(ResearchAreaLog.class)
	@Select(ResearchAreaLog.class)	
	public abstract List<EditResearchAreaLog> query(Connection con,String professorId) throws SQLException;
	
}
