package com.ekexiu.portal.job;

import java.sql.Connection;
import java.sql.SQLException;

import javax.sql.DataSource;

import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.annotation.Bean;
import org.jfw.util.DateUtil;
import org.jfw.util.jdbc.JdbcUtil;

import com.ekexiu.portal.dao.DemandDao;

@Bean
public class DemandInvalidJob implements Runnable {
	@Autowrie("dataSource")
	private DataSource dataSource;
	@Autowrie
	private DemandDao demandDao;

	public DataSource getDataSource() {
		return dataSource;
	}

	public void setDataSource(DataSource dataSource) {
		this.dataSource = dataSource;
	}

	public DemandDao getDemandDao() {
		return demandDao;
	}

	public void setDemandDao(DemandDao demandDao) {
		this.demandDao = demandDao;
	}

	private String lastDay;

	synchronized private void hand() {
		String cday = DateUtil.formatDate(System.currentTimeMillis());
		if (!cday.equals(lastDay)) {
			try {
				Connection con = this.dataSource.getConnection();
				try {
					boolean ac = con.getAutoCommit();
					try {
						con.setAutoCommit(false);
						try {
							demandDao.invalid(con, cday);
							con.commit();
							lastDay = cday;
						} catch (SQLException se) {
							JdbcUtil.rollback(con);
							throw se;
						}
					} finally {
						con.setAutoCommit(ac);
					}
				} finally {
					JdbcUtil.close(con);
				}

			} catch (Throwable thr) {
			}
		}
	}

	@Override
	public void run() {
		this.hand();
	}

}
