package com.ekexiu.portal.org;

import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.operate.Post;
import org.jfw.apt.web.annotation.param.JdbcConn;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

@Path("/org/linkman")
public class OrgLinkManService {

	@Autowrie
	private OrgLinkManDao orgLinkManDao;

	public OrgLinkManDao getOrgLinkManDao() {
		return orgLinkManDao;
	}

	public void setOrgLinkManDao(OrgLinkManDao orgLinkManDao) {
		this.orgLinkManDao = orgLinkManDao;
	}

	@Post
	@Path("/delete")
	public int delete(@JdbcConn Connection con, @Nullable String oid, @Nullable String pid) throws SQLException {
		if (oid != null) {
			return this.orgLinkManDao.deleteByOid(con, oid);
		} else if (pid != null) {
			return this.orgLinkManDao.deleteByPid(con, pid);
		}
		return 0;
	}

	@Post
	@Path("/save")
	public void save(@JdbcConn(true) Connection con, String oid, String[] pid) throws SQLException {
		this.orgLinkManDao.deleteByOid(con, oid);
		OrgLinkMan[] men = new OrgLinkMan[pid.length];
		for (int i = 0; i < pid.length; ++i) {
			OrgLinkMan man = new OrgLinkMan();
			if (pid[i] == null)
				throw new IllegalArgumentException("invalid parameter pid[" + i + "] is null");
			int idx = pid[i].indexOf(',');
			if(idx<=0) 	throw new IllegalArgumentException("invalid parameter pid[" + i + "]  ="+pid[i]);
			
			man.setOid(oid);
			man.setSeq(Integer.parseInt(pid[i].substring(0,idx)));
			man.setPid(pid[i].substring(++idx));
			men[i]=man;
		}
		this.orgLinkManDao.insert(con, men);
	}
	
	@Get
	@Path("/queryAll")
	public List<OrgLinkMan> query(@JdbcConn Connection con,String oid)throws SQLException{
		return orgLinkManDao.queryByOid(con, oid);
	}

}
