package com.ekexiu.portal.platform.msg;

import org.jfw.apt.annotation.DefaultValue;
import org.jfw.apt.orm.annotation.dao.Column;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.LimitColumn;
import org.jfw.apt.orm.annotation.dao.method.OrderBy;
import org.jfw.apt.orm.annotation.dao.method.SetSentence;
import org.jfw.apt.orm.annotation.dao.method.Where;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;
import org.jfw.apt.orm.annotation.dao.method.operator.LimitSelect;
import org.jfw.apt.orm.annotation.dao.method.operator.QueryVal;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectList;
import org.jfw.apt.orm.annotation.dao.method.operator.UpdateWith;
import org.jfw.apt.orm.annotation.dao.param.Alias;
import org.jfw.apt.orm.annotation.dao.param.GtEq;
import org.jfw.apt.orm.annotation.dao.param.LessThan;
import org.jfw.apt.orm.annotation.dao.param.Set;
import org.jfw.apt.orm.core.defaultImpl.IntHandler;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;


@DAO
public interface PlatformMsgDao {

	
	@SelectList
	@OrderBy("ORDER BY OP_TIME DESC")
	@Where("ACTIVED ='1'")
	List<PlatformMsgIdx> query(Connection con,String provider)throws SQLException;
	
	@SelectList
	@OrderBy("ORDER BY OP_TIME DESC")
	List<PlatformMsgRec> query(Connection con,String provider,String pid,String requestor)throws SQLException;
	
	@LimitSelect
	@OrderBy(cols={ @LimitColumn(value = "opTime", asc = true), 
		@LimitColumn(value = "provider", asc = false),
		@LimitColumn(value = "requestor", asc = false) }, value = "")
	@Where("MSG_TYPE=1")
	List<PlatformMsgRec> queryOld(Connection con,String pid,String opTime,String provider,String requestor,int rows)throws SQLException;
	
	@Insert
	int insert(Connection con,PlatformMsgRec mr)throws SQLException;
	@Insert
	int insert(Connection con,PlatformMsgIdx mi)throws SQLException;
	
	@UpdateWith
	@From(PlatformMsgIdx.class)
	@SetSentence("UNREAD=0")
	int readed(Connection con,String provider,String pid,String requestor)throws SQLException;
	@UpdateWith
	@From(PlatformMsgIdx.class)
	@SetSentence("ACTIVED='0' ,UNREAD=0")
	int delete(Connection con,String provider,String pid,String requestor)throws SQLException;
	
	
	
	@UpdateWith
	@From(PlatformMsgIdx.class)
	int updateActivedIdx(Connection con,String requestor,String provider,String pid, @LessThan @Alias("opTime") String time ,@Set String cnt,@Set String opTime  )throws SQLException;
	
	
	@UpdateWith
	@From(PlatformMsgIdx.class)
	@SetSentence("ACTIVED='1' ,UNREAD=UNREAD+1")
	int updateIdxFlag(Connection con,String provider,String pid,String requestor,@GtEq String opTime)throws SQLException;
	
	@UpdateWith
	@From(PlatformMsgIdx.class)
	@SetSentence("ACTIVED='1' ,UNREAD=UNREAD+1")
	int updateIdxFull(Connection con,String provider,String pid,String requestor, @LessThan @Alias("opTime") String time,@Set String cnt,@Set String opTime)throws SQLException;

	@QueryVal
	@From(PlatformMsgIdx.class)
	@DefaultValue("0")
	@Column(value="SUM(UNREAD)",handlerClass= IntHandler.class)
	int unreadSum(Connection con,String provider) throws SQLException;
	
}
