package com.ekexiu.portal.question;

import org.jfw.apt.orm.annotation.entry.Column;
import org.jfw.apt.orm.annotation.entry.PrimaryKey;
import org.jfw.apt.orm.annotation.entry.Table;
import org.jfw.apt.orm.annotation.entry.Unique;
import org.jfw.apt.orm.annotation.entry.Uniques;
import org.jfw.apt.orm.core.enums.DE;

@PrimaryKey("id")
@Uniques({@Unique(clolumns={"qid","uid"},name="UNI_ANSWER_QID_UID")})
@Table
public class Answer {
	private String id;
	private String qid;
	private String uid;
	private String state;
	private String cnt;
	private long agree;
	private long  ballot;
	private String createTime;
	private String modifyTime;
	private transient String timeDesc;
	
	@Column(DE.text_de)
	public String getTimeDesc() {
		return timeDesc;
	}
	public void setTimeDesc(String timeDesc) {
		this.timeDesc = timeDesc;
	}
	/**
	 * ID
	 * @return
	 */
	@Column(DE.id_32)
	public String getId() {
		return id;
	}
	public void setId(String id) {
		this.id = id;
	}
	/**
	 * 问题ID
	 * @return
	 */
	@Column(DE.text_de)
	public String getQid() {
		return qid;
	}
	public void setQid(String qid) {
		this.qid = qid;
	}
	/**
	 * 回答人ID
	 * @return
	 */
	@Column(DE.text_de)
	public String getUid() {
		return uid;
	}
	public void setUid(String uid) {
		this.uid = uid;
	}
	/**
	 * 状态 1：发布中   
	 * @return
	 */
	@Column(DE.singleChar)
	public String getState() {
		return state;
	}
	public void setState(String state) {
		this.state = state;
	}
	/**
	 * 回答内容
	 * @return
	 */
	@Column(DE.text_de)
	public String getCnt() {
		return cnt;
	}
	public void setCnt(String cnt) {
		this.cnt = cnt;
	}
	/**
	 * 点赞数量
	 */
	@Column(DE.long_de)
	public long getAgree() {
		return agree;
	}
	public void setAgree(long agree) {
		this.agree = agree;
	}
	/**
	 * 总数投票数
	 * @return
	 */
	@Column(DE.long_de)
	public long getBallot() {
		return ballot;
	}
	public void setBallot(long ballot) {
		this.ballot = ballot;
	}
	@Column(DE.text_de)
	public String getCreateTime() {
		return createTime;
	}
	public void setCreateTime(String createTime) {
		this.createTime = createTime;
	}
	@Column(DE.text_de)
	public String getModifyTime() {
		return modifyTime;
	}
	public void setModifyTime(String modifyTime) {
		this.modifyTime = modifyTime;
	}
	
	
	
	
	
}
