package com.ekexiu.portal.resResult;

import com.ekexiu.portal.basepo.CreateTimeSupported;
import com.ekexiu.portal.basepo.ModifyTimeSupported;
import org.jfw.apt.orm.annotation.entry.Column;
import org.jfw.apt.orm.annotation.entry.PrimaryKey;
import org.jfw.apt.orm.annotation.entry.Table;
import org.jfw.apt.orm.core.enums.DE;

/**
 * Created by TT on 2019/7/8.
 */
@Table(descp = "成果")
@PrimaryKey("id")
public class ResearchResult implements CreateTimeSupported, ModifyTimeSupported {
    private String id;
    private String name;
    private String level;
    private String orgId;
    private String department;
    private String subject;
    private String industry;
    private String descp;
    private String applyDescp;
    private String prospect;
    private String indicator;
    private String advantage;
    private String benefit;
    private String cooperation;
    private String pic;
    private String createTime;
    private String modifyTime;
    private String status;

    private String creator;
    private boolean platform;
    private boolean console;
    private boolean professor;

    private long pageViews;

    @Column(DE.id_32)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Column(descp = "成果名称",value = DE.text_de)
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Column(descp = "技术水平",value =DE.Text_de)
    public String getLevel() {
        return level;
    }

    public void setLevel(String level) {
        this.level = level;
    }

    @Column(descp = "所属机构",value =DE.REFID_32)
    public String getOrgId() {
        return orgId;
    }

    public void setOrgId(String orgId) {
        this.orgId = orgId;
    }

    @Column(descp = "所属部门",value =DE.Text_de)
    public String getDepartment() {
        return department;
    }

    public void setDepartment(String department) {
        this.department = department;
    }

    @Column(descp = "学术领域",value =DE.Text_de)
    public String getSubject() {
        return subject;
    }

    public void setSubject(String subject) {
        this.subject = subject;
    }

    @Column(descp = "应用领域",value =DE.Text_de)
    public String getIndustry() {
        return industry;
    }

    public void setIndustry(String industry) {
        this.industry = industry;
    }

    @Column(descp = "成果简介",value =DE.Text_de)
    public String getDescp() {
        return descp;
    }

    public void setDescp(String descp) {
        this.descp = descp;
    }

    @Column(descp = "应用介绍",value =DE.Text_de)
    public String getApplyDescp() {
        return applyDescp;
    }

    public void setApplyDescp(String applyDescp) {
        this.applyDescp = applyDescp;
    }

    @Column(descp = "产业化前景",value =DE.Text_de)
    public String getProspect() {
        return prospect;
    }

    public void setProspect(String prospect) {
        this.prospect = prospect;
    }

    @Column(descp = "技术指标",value =DE.Text_de)
    public String getIndicator() {
        return indicator;
    }

    public void setIndicator(String indicator) {
        this.indicator = indicator;
    }

    @Column(descp = "技术优势",value =DE.Text_de)
    public String getAdvantage() {
        return advantage;
    }

    public void setAdvantage(String advantage) {
        this.advantage = advantage;
    }

    @Column(descp = "经济和社会化效益",value =DE.Text_de)
    public String getBenefit() {
        return benefit;
    }

    public void setBenefit(String benefit) {
        this.benefit = benefit;
    }

    @Column(descp = "合作备注",value =DE.Text_de)
    public String getCooperation() {
        return cooperation;
    }

    public void setCooperation(String cooperation) {
        this.cooperation = cooperation;
    }

    @Column(descp = "图片",value =DE.Text_de)
    public String getPic() {
        return pic;
    }

    public void setPic(String pic) {
        this.pic = pic;
    }

    @Override
    public String getCreateTime() {
        return createTime;
    }

    @Override
    public void setCreateTime(String createTime) {
        this.createTime = createTime;
    }

    @Override
    public String getModifyTime() {
        return modifyTime;
    }

    @Override
    public void setModifyTime(String modifyTime) {
        this.modifyTime = modifyTime;
    }

    @Column(descp = "创建人ID", value = DE.id_32)
    public String getCreator() {
        return creator;
    }

    public void setCreator(String creator) {
        this.creator = creator;
    }

    @Column(descp = "状态 0：删除，1:发布的 ，2：草稿", value = DE.singleChar)
    public String getStatus() {
        return status;
    }

    public void setStatus(String status) {
        this.status = status;
    }

    @Column(descp = "是否是平台用户", value = DE.boolean_de)
    public boolean isPlatform() {
        return platform;
    }

    public void setPlatform(boolean platform) {
        this.platform = platform;
    }

    @Column(descp = "是否是后台用户", value = DE.boolean_de)
    public boolean isConsole() {
        return console;
    }

    public void setConsole(boolean console) {
        this.console = console;
    }

    @Column(descp = "是否是专家用户", value = DE.boolean_de)
    public boolean isProfessor() {
        return professor;
    }

    public void setProfessor(boolean professor) {
        this.professor = professor;
    }

    @Column(descp="浏览量",value = DE.long_de)
    public long getPageViews() {
        return pageViews;
    }

    public void setPageViews(long pageViews) {
        this.pageViews = pageViews;
    }
}
