package com.ekexiu.portal.service;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.sql.Connection;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.Date;

import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Post;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.util.StringUtil;
import org.jfw.util.io.IoUtil;

import com.ekexiu.portal.dao.OperateServiceFileDao;
import com.ekexiu.portal.po.OperateServiceFile;

@Path("/operateServiceFile")
public class OperateServiceFileService {
	private File tmpPath;
	private File serviceFilePath;
	@Autowrie
	private OperateServiceFileDao serviceFileDao;
	public File getTmpPath() {
		return tmpPath;
	}
	public void setTmpPath(File tmpPath) {
		this.tmpPath = tmpPath;
	}
	public File getServiceFilePath() {
		return serviceFilePath;
	}
	public void setServiceFilePath(File serviceFilePath) {
		this.serviceFilePath = serviceFilePath;
	}
	public OperateServiceFileDao getServiceFileDao() {
		return serviceFileDao;
	}
	public void setServiceFileDao(OperateServiceFileDao serviceFileDao) {
		this.serviceFileDao = serviceFileDao;
	}
	
	@Post
	@Path
	public String insert(@JdbcConn(true) Connection con,String serviceLogId,String fn,String fileName)throws SQLException, IOException{
		String serviceFileId = StringUtil.buildUUID();
		InputStream in = new FileInputStream(new File(this.tmpPath, fn));
		SimpleDateFormat df = new SimpleDateFormat("yyyyMMdd");
		String date = df.format(new Date());
		File dateFile = new File(this.serviceFilePath + "/" + date);
		if (!dateFile.exists()) {
			dateFile.mkdirs();
		}
		try {
			IoUtil.copy(in, new FileOutputStream(new File(dateFile, serviceFileId)), false, true);
		} finally {
			in.close();
		}
		String src = date + "/" + serviceFileId;
		OperateServiceFile serviceFile = new OperateServiceFile();
		serviceFile.setServiceFileId(serviceFileId);
		serviceFile.setFileSrc(src);
		serviceFile.setFileName(fileName);
		serviceFile.setServiceLogId(serviceLogId);
		this.serviceFileDao.insert(con, serviceFile);
		return serviceFileId;
	}
	
}
