package com.ekexiu.portal.service;

import com.ekexiu.portal.dao.PaperAgreeDao;
import com.ekexiu.portal.dao.PaperAuthorDao;
import com.ekexiu.portal.dao.PpaperDao;
import com.ekexiu.portal.notify.NotifyService;
import com.ekexiu.portal.notify.NotifyType;
import com.ekexiu.portal.po.PaperAgree;
import com.ekexiu.portal.po.PaperAuthor;
import com.ekexiu.portal.po.Ppaper;
import com.ekexiu.portal.pojo.AssedPaper;
import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.annotation.DefaultValue;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.operate.Post;
import org.jfw.apt.web.annotation.param.AfterCommit;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.util.PageQueryResult;
import org.jfw.util.exception.JfwBaseException;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.Collections;
import java.util.List;

@Path("/ppaper")
public class PpaperService {

	@Autowrie
	private PpaperDao ppaperDao;
	@Autowrie
	private PaperAuthorDao paperAuthorDao;

	@Autowrie
	private KeyWordService keyWordService;

	@Autowrie
	private PaperAgreeDao paperAgreeDao;

	@Autowrie
	private NotifyService notifyService;

	@Autowrie
	private GrowthLogService growthLogService;
	
	
	public GrowthLogService getGrowthLogService() {
		return growthLogService;
	}

	public void setGrowthLogService(GrowthLogService growthLogService) {
		this.growthLogService = growthLogService;
	}

	public NotifyService getNotifyService() {
		return notifyService;
	}

	public void setNotifyService(NotifyService notifyService) {
		this.notifyService = notifyService;
	}

	public PaperAgreeDao getPaperAgreeDao() {
		return paperAgreeDao;
	}

	public void setPaperAgreeDao(PaperAgreeDao paperAgreeDao) {
		this.paperAgreeDao = paperAgreeDao;
	}

	public KeyWordService getKeyWordService() {
		return keyWordService;
	}

	public void setKeyWordService(KeyWordService keyWordService) {
		this.keyWordService = keyWordService;
	}

	public PpaperDao getPpaperDao() {
		return ppaperDao;
	}

	public void setPpaperDao(PpaperDao ppaperDao) {
		this.ppaperDao = ppaperDao;
	}

	public PaperAuthorDao getPaperAuthorDao() {
		return paperAuthorDao;
	}

	public void setPaperAuthorDao(PaperAuthorDao paperAuthorDao) {
		this.paperAuthorDao = paperAuthorDao;
	}

	@Get
	@Path("/qo")
	public Ppaper query(@JdbcConn Connection con, String id) throws SQLException {
		return this.ppaperDao.query(con, id);
	}

	@Get
	@Path("/qm")
	public List<Ppaper> query(@JdbcConn Connection con, String[] id) throws SQLException {
		return this.ppaperDao.query(con, id);
	}

	@Get
	@Path("/byProfessor")
	public PageQueryResult<AssedPaper> queryByProfessor(@JdbcConn Connection con, String id, @Nullable String name, @DefaultValue("10") int pageSize,
			@DefaultValue("1") int pageNo) throws SQLException {
		if (name == null) {
			name = "%";
		} else {
			name = "%" + name + "%";
		}
		return this.ppaperDao.pageQueryWithProfessor(con, id, name, pageSize, pageNo);
	}

	@Get
	@Path("/professor")
	public List<AssedPaper> queryProfessor(@JdbcConn Connection con,String owner,@Nullable String name,@DefaultValue("\"9\"")String assTime,@DefaultValue("\"Z\"")String id,int rows)throws SQLException {
		if (name == null) {
			name = "%";
		} else {
			name = "%" + name + "%";
		}
		return this.ppaperDao.queryProfessor(con, owner, name, assTime, id,rows);
	}

	@Get
	@Path("/byAuthor")
	public PageQueryResult<AssedPaper> queryByAuthor(@JdbcConn Connection con, String author, String id, @Nullable String name,
			@DefaultValue("10") int pageSize, @DefaultValue("1") int pageNo) throws SQLException {
		if (name == null) {
			name = "%";
		} else {
			name = "%" + name + "%";
		}
		return this.ppaperDao.pageQueryWithAuthor(con, author, id, name, pageSize, pageNo);
	}

	@Get
	@Path("/authors")
	public List<PaperAuthor> queryAuthors(@JdbcConn Connection con, String id) throws SQLException {
		return this.paperAuthorDao.query(con, id);
	}

	@Get
	@Path("/pq")
	public PageQueryResult<Ppaper> pageQuery(@JdbcConn Connection con, @Nullable String qw, @DefaultValue("20") int pageSize, @DefaultValue("1") int pageNo)
			throws SQLException {
		return null == qw ? this.ppaperDao.query(con, pageSize, pageNo) : this.ppaperDao.query(con, "%" + qw + "%", pageSize, pageNo);
	}

	@Get
	@Path("/index/search")
	public List<Ppaper> indexSearch(@JdbcConn Connection con, @Nullable String key, @DefaultValue("Long.MAX_VALUE") long sortNum, @DefaultValue("\"9\"") String createTime,@DefaultValue("\"G\"")String id, @DefaultValue("10000000") int rows)throws SQLException {
		if (key != null) {
			key = "%" + key + "%";
		}
		return this.ppaperDao.indexSearch(con, key, sortNum, createTime, id, rows);

	}
	/**
	 * 
	 * @param con
	 * @param uid
	 *            专家ID(用户ID)
	 * @param id
	 *            论文ID
	 * @param author
	 *            作者名称
	 * @return
	 * @throws SQLException
	 */
	@Post
	@Path("/ass")
	public int ass(@JdbcConn(true) Connection con, String uid, String id, String author) throws SQLException {
		return this.paperAuthorDao.update(con, id, uid, author);
	}

	/**
	 * 
	 * @param con
	 * @param uid
	 *            专家ID(用户ID)
	 * @param id
	 *            论文ID
	 * @return
	 * @throws SQLException
	 */
	@Post
	@Path("/cAss")
	public int cAss(@JdbcConn(true) Connection con, String uid, String id) throws SQLException {
		return this.paperAuthorDao.update(con, id, uid);
	}

	@Post
	@Path("/incPageViews")
	public void incPageViews(@JdbcConn(true) Connection con, String id) throws SQLException {
		this.ppaperDao.incPageViews(con, id);
	}

	@Post
	@Path("/kw")
	public void update(@JdbcConn(true) Connection con, String id, @Nullable String keywords) throws SQLException {
		this.ppaperDao.update(con, id, keywords);
		this.keyWordService.refreshPaper(con, id, KeyWordService.splitKeyWord(keywords));
	}

	@Get
	@Path("/byShareId")
	public Ppaper query(@JdbcConn Connection con, long id) throws SQLException {
		return this.ppaperDao.query(con, id);
	}

	@Get
	@Path("/ralatePapers")
	public List<Ppaper> ralatePapers(@JdbcConn Connection con, String paperId, @DefaultValue("5") int rows) throws SQLException {
		String[] ids = this.ppaperDao.queryPaperIdWithSameKeyWord(con, paperId, rows);
		if (ids != null) {
			return this.ppaperDao.query(con, ids);
		}
		return Collections.<Ppaper> emptyList();
	}

	@Post
	@Path("/agree")
	public void agree(@JdbcConn(true) Connection con, String id, String uid,@Nullable String uname, @AfterCommit List<Runnable> runs) throws SQLException, JfwBaseException {
		Ppaper p = this.ppaperDao.query(con, id);
		if (p == null) {
			throw new JfwBaseException(50000, "paper[" + id + "] not found");
		}
		PaperAgree pa = new PaperAgree();
		pa.setOpId(uid);
		pa.setPaperId(id);
		this.paperAgreeDao.insert(con, pa);
		this.growthLogService.agree(con, uid);
		if (uname != null) {
			List<PaperAuthor> pas = this.paperAuthorDao.query(con, id);
			for (PaperAuthor au : pas) {
				if (!au.getProfessorId().startsWith("#") && (!uid.equals(au.getProfessorId()))) {
					this.notifyService.notify(con, au.getProfessorId(), uid, uname, id, p.getName(), NotifyType.AGREE_PAPER, runs);
				}
			}
		}
	}

	// @Post
	// @Path("/unAgree")
	// public void unAgree(@JdbcConn(true) Connection con,String id,String
	// uid)throws SQLException{
	// this.paperAgreeDao.delete(con,uid, id);
	// }

	@Get
	@Path("/agree")
	public boolean hasAgree(@JdbcConn(false) Connection con, String id, String uid) throws SQLException {
		return null != this.paperAgreeDao.query(con, uid, id);
	}

	@Get
	@Path("/agreeCount")
	public int agreeCount(@JdbcConn(false) Connection con, String id) throws SQLException {
		return this.paperAgreeDao.query(con, id);
	}

	@Get
	@Path("/assPapers")
	public List<Ppaper> assPapers(@JdbcConn Connection con, String[] kws, @DefaultValue("5") int rows) throws SQLException {
		if (kws == null || kws.length == 0)
			return Collections.<Ppaper> emptyList();
		String[] ids = this.ppaperDao.queryPatentIdWithKeyWord(con, kws, rows);
		if (ids == null || ids.length == 0)
			return Collections.<Ppaper> emptyList();
		return this.ppaperDao.query(con, ids);
	}

	@Get
	@Path("/count/publish")
	public long countPublish(@JdbcConn Connection con,String owner)throws SQLException {
		return this.ppaperDao.countPublish(con, owner);
	}
}
