package com.ekexiu.portal.system;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.operate.Post;
import org.jfw.apt.web.annotation.param.AfterCommit;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.util.DateUtil;
import org.jfw.util.StringUtil;
import org.jfw.util.exception.JfwBaseException;

import com.ekexiu.portal.dao.OrgDao;
import com.ekexiu.portal.mail.MailService;
import com.ekexiu.portal.po.Organization;
import com.ekexiu.portal.pojo.EditOrganization;
import com.ekexiu.portal.service.ImageService;

@Path()
public class SysMailService {

	
	private long timeoutOfOrgInviteLog = 1000 *60 * 60 *24;
	private String orgInviteCodeKey;
	private String orgInviteNameKey;
	private String orgInviteTemplate;
	@Autowrie
	private MailService mailservice;
	@Autowrie
	private OrgDao orgDao;
	@Autowrie
	private OrgInviteLogDao orgInviteLogDao;
	
	@Autowrie
	private ImageService imageService;
	
	
	

	public ImageService getImageService() {
		return imageService;
	}

	public void setImageService(ImageService imageService) {
		this.imageService = imageService;
	}

	public long getTimeoutOfOrgInviteLog() {
		return timeoutOfOrgInviteLog;
	}

	public void setTimeoutOfOrgInviteLog(long timeoutOfOrgInviteLog) {
		this.timeoutOfOrgInviteLog = timeoutOfOrgInviteLog;
	}

	public String getOrgInviteCodeKey() {
		return orgInviteCodeKey;
	}

	public void setOrgInviteCodeKey(String orgInviteCodeKey) {
		this.orgInviteCodeKey = orgInviteCodeKey;
	}

	public String getOrgInviteNameKey() {
		return orgInviteNameKey;
	}

	public void setOrgInviteNameKey(String orgInviteNameKey) {
		this.orgInviteNameKey = orgInviteNameKey;
	}

	public String getOrgInviteTemplate() {
		return orgInviteTemplate;
	}

	public void setOrgInviteTemplate(String orgInviteTemplate) {
		this.orgInviteTemplate = orgInviteTemplate;
	}

	public MailService getMailservice() {
		return mailservice;
	}

	public void setMailservice(MailService mailservice) {
		this.mailservice = mailservice;
	}

	public OrgDao getOrgDao() {
		return orgDao;
	}

	public void setOrgDao(OrgDao orgDao) {
		this.orgDao = orgDao;
	}

	public OrgInviteLogDao getOrgInviteLogDao() {
		return orgInviteLogDao;
	}

	public void setOrgInviteLogDao(OrgInviteLogDao orgInviteLogDao) {
		this.orgInviteLogDao = orgInviteLogDao;
	}

	@Get
	@Path("/cleanInviteOrg")
	public void cleanInviteOrg(@JdbcConn(true) Connection con) throws SQLException{
		String time = DateUtil.formatDateTime(System.currentTimeMillis()-this.timeoutOfOrgInviteLog);
		this.orgInviteLogDao.delete(con, time);
	}
	
	@Post
	@Path("/sendMailWithInviteOrg")
	public void send(@JdbcConn(true) Connection con, final String mail, String oid, @AfterCommit List<Runnable> runs) throws SQLException, JfwBaseException {

		final Organization org = orgDao.query(con, oid);
		if (org == null) {
			throw new JfwBaseException(-600001, "invalid param oid");
		}

		final String logId = StringUtil.buildUUID();
		OrgInviteLog log = new OrgInviteLog();
		log.setId(logId);
		log.setOid(oid);
		orgInviteLogDao.insert(con, log);

		final Map<String, String> map = new HashMap<String, String>();
		map.put(this.orgInviteCodeKey, logId);
		map.put(orgInviteNameKey, org.getName());
		final String mailTitle = "「科袖网」 " + org.getName() + " 邀请您成为企业认证员工";

		runs.add(new Runnable() {

			@Override
			public void run() {
				try {
					mailservice.sendSimpleMail(mail, orgInviteTemplate, map, mailTitle);
				} catch (Exception e) {
				}
			}
		});
	}
	
	@Get
	@Path("/queryOrgByOrgInviteLogId")
	public EditOrganization queryOrgByOrgInviteLogId(@JdbcConn Connection con,String code)throws SQLException{
		OrgInviteLog log = this.orgInviteLogDao.query(con,code);
		if(log!=null){
			String time = DateUtil.formatDateTime(System.currentTimeMillis()-this.timeoutOfOrgInviteLog);
			if(time.compareTo(log.getCreateTime())<=0){
				EditOrganization eo = this.orgDao.queryEditOrg(con,log.getOid());
				if(eo!=null){
					eo.setHasOrgLogo(this.imageService.hasOrgLogo(eo.getId()));
					return eo;
				}
			}
		}
		return null;
	}
	
	
	
	

}
