package com.ekexiu.portal.util;

import java.io.IOException;
import java.lang.reflect.Type;
import java.net.HttpURLConnection;
import java.net.URL;

import org.jfw.util.ConstData;
import org.jfw.util.io.IoUtil;
import org.jfw.util.json.JsonService;

public final class HttpUtil {
    public static String loadAsString(String url, String enc) throws IOException {
        URL aurl = new URL(url);
        HttpURLConnection uc = (HttpURLConnection) aurl.openConnection();
        try {
            byte[] bs = IoUtil.readStream(uc.getInputStream(), true);
            return new String(bs, enc);
        } finally {
            try {
                uc.disconnect();
            } catch (Throwable th) {
            }
        }
    }

    public static String loadAsString(String url) throws IOException {
        URL aurl = new URL(url);
        HttpURLConnection uc = (HttpURLConnection) aurl.openConnection();
        try {
            byte[] bs = IoUtil.readStream(uc.getInputStream(), true);
            return new String(bs, ConstData.UTF8);
        } finally {
            try {
                uc.disconnect();
            } catch (Throwable th) {
            }
        }
    }
    
    public static byte[] load(String url)throws IOException{
    	   URL aurl = new URL(url);
           HttpURLConnection uc = (HttpURLConnection) aurl.openConnection();
           try {
               return IoUtil.readStream(uc.getInputStream(), true);
           } finally {
               try {
                   uc.disconnect();
               } catch (Throwable th) {
               }
           }
    }

    public static <T> T loadJsonObject(String url, String enc, Type typeOfT) throws IOException {
        URL aurl = new URL(url);
        HttpURLConnection uc = (HttpURLConnection) aurl.openConnection();
        try {
            byte[] bs = IoUtil.readStream(uc.getInputStream(), true);
            return JsonService.fromJson(new String(bs, enc), typeOfT);
        } finally {
            try {
                uc.disconnect();
            } catch (Throwable th) {
            }
        }
    }

    public static <T> T loadJsonObject(String url, Type typeOfT) throws IOException {
        URL aurl = new URL(url);
        HttpURLConnection uc = (HttpURLConnection) aurl.openConnection();
        try {
            byte[] bs = IoUtil.readStream(uc.getInputStream(), true);
            return JsonService.fromJson(new String(bs, ConstData.UTF8), typeOfT);
        } finally {
            try {
                uc.disconnect();
            } catch (Throwable th) {
            }
        }
    }

    public static <T> T loadJsonObject(String url, String enc, Class<T> clazz) throws IOException {
        URL aurl = new URL(url);
        HttpURLConnection uc = (HttpURLConnection) aurl.openConnection();
        try {
            byte[] bs = IoUtil.readStream(uc.getInputStream(), true);
            return JsonService.fromJson(new String(bs, enc), clazz);
        } finally {
            try {
                uc.disconnect();
            } catch (Throwable th) {
            }
        }
    }

    public static <T> T loadJsonObject(String url, Class<T> clazz) throws IOException {
        URL aurl = new URL(url);
        HttpURLConnection uc = (HttpURLConnection) aurl.openConnection();
        try {
            byte[] bs = IoUtil.readStream(uc.getInputStream(), true);
            return JsonService.fromJson(new String(bs, ConstData.UTF8), clazz);
        } finally {
            try {
                uc.disconnect();
            } catch (Throwable th) {
            }
        }
    }
}
